"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var DropDownInput_module_scss_1 = __importDefault(require("./DropDownInput.module.scss"));
var react_2 = require("react");
var use_click_outside_1 = __importDefault(require("../../hooks/use-click-outside"));
var Icons_1 = require("../Icons/Icons");
var use_parent_props_1 = __importDefault(require("../../hooks/use-parent-props"));
var react_transition_group_1 = require("react-transition-group");
var Utilities_1 = require("../../interfaces/Utilities");
function DropDownInput(_a) {
    var options = _a.options, label = _a.label, onChange = _a.onChange;
    var _b = (0, react_2.useState)(), menuTitleIndex = _b[0], setMenuTitleIndex = _b[1];
    var _c = (0, react_2.useState)(false), isOpen = _c[0], setIsOpen = _c[1];
    var _d = (0, use_parent_props_1.default)(), parentRef = _d.ref, parentProps = _d.parentProps;
    var menuRef = (0, use_click_outside_1.default)(function () { return setIsOpen(false); }, parentRef).ref;
    var handleMenuToggle = function () {
        setIsOpen(!isOpen);
    };
    var handleSelect = function (new_title_index) {
        setMenuTitleIndex(new_title_index);
        onChange();
        setIsOpen(false);
    };
    var inputWidth = Math.max(Math.max.apply(Math, options.map(function (el) { return el.length; })), "Select".length) *
        1.7;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        label && react_1.default.createElement("label", { className: DropDownInput_module_scss_1.default.label }, label),
        react_1.default.createElement("button", { style: {
                width: "".concat(inputWidth, "ch"),
            }, ref: parentRef, className: DropDownInput_module_scss_1.default.title, onClick: handleMenuToggle },
            react_1.default.createElement("span", null, menuTitleIndex !== undefined ? options[menuTitleIndex] : "Select"),
            react_1.default.createElement(Icons_1.ArrowIcon, { className: DropDownInput_module_scss_1.default.arrow, direction: Utilities_1.Direction.down })),
        react_1.default.createElement(react_transition_group_1.CSSTransition, { nodeRef: menuRef, in: isOpen, timeout: 300, classNames: {
                enter: DropDownInput_module_scss_1.default.menuEnter,
                enterActive: DropDownInput_module_scss_1.default.menuEnterActive,
                exit: DropDownInput_module_scss_1.default.menuExit,
                exitActive: DropDownInput_module_scss_1.default.menuExitActive,
            }, unmountOnExit: true },
            react_1.default.createElement("ul", { ref: menuRef, className: DropDownInput_module_scss_1.default.menu, style: {
                    width: "".concat(inputWidth + 3.5, "ch"),
                    top: "".concat(parentProps.top + 30, "px"),
                    left: "".concat(parentProps.left, "px"),
                } }, options.map(function (value, index) {
                return (react_1.default.createElement("li", { className: "".concat(index === menuTitleIndex ? DropDownInput_module_scss_1.default.selected : ""), key: index, onClick: function () { return handleSelect(index); } }, value));
            })))));
}
exports.default = DropDownInput;
