"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MenuItems = void 0;
var react_1 = __importDefault(require("react"));
var DropDownMenu_module_scss_1 = __importDefault(require("./DropDownMenu.module.scss"));
var react_2 = require("react");
var use_click_outside_1 = __importDefault(require("../../hooks/use-click-outside"));
var Icons_1 = require("../Icons/Icons");
var use_parent_props_1 = __importDefault(require("../../hooks/use-parent-props"));
var react_transition_group_1 = require("react-transition-group");
var Link_1 = __importDefault(require("../Link/Link"));
var Utilities_1 = require("../../interfaces/Utilities");
var getArrowDirection = function (menuPosition, isOpen) {
    switch (menuPosition) {
        case Utilities_1.Direction.down:
            if (isOpen)
                return Utilities_1.Direction.up;
            return Utilities_1.Direction.down;
        case Utilities_1.Direction.up:
            if (isOpen)
                return Utilities_1.Direction.down;
            return Utilities_1.Direction.up;
        case Utilities_1.Direction.left:
            if (isOpen)
                return Utilities_1.Direction.right;
            return Utilities_1.Direction.left;
        case Utilities_1.Direction.right:
            if (isOpen)
                return Utilities_1.Direction.left;
            return Utilities_1.Direction.right;
    }
};
function DropDownMenu(_a) {
    var _b;
    var menuItems = _a.menuItems, label = _a.label, menuPosition = _a.menuPosition;
    menuPosition = menuPosition ? menuPosition : Utilities_1.Direction.down;
    var _c = (0, react_2.useState)(false), isOpen = _c[0], setIsOpen = _c[1];
    var _d = (0, react_2.useState)(menuItems), activeMenu = _d[0], setActiveMenu = _d[1];
    var _e = (0, use_parent_props_1.default)(), parentRef = _e.ref, parentProps = _e.parentProps;
    var menuRef = (0, use_click_outside_1.default)(function () { return setIsOpen(false); }, parentRef).ref;
    var handleMenuToggle = function () {
        setIsOpen(!isOpen);
    };
    var arrowPosition = function () { return getArrowDirection(menuPosition, isOpen); };
    var getMenuPosition = function () {
        var _a;
        switch (menuPosition) {
            case Utilities_1.Direction.down:
                return {
                    top: "".concat(parentProps.top + 30, "px"),
                    left: "".concat(parentProps.left, "px"),
                };
            case Utilities_1.Direction.right:
                return {
                    top: "".concat(parentProps.top - 16, "px"),
                    left: "".concat(parentProps.right + 5, "px"),
                };
            case Utilities_1.Direction.left:
                return {
                    top: "".concat(parentProps.top - 16, "px"),
                    left: "".concat(parentProps.left - parentProps.width - 5, "px"),
                };
            case Utilities_1.Direction.up:
                var rowHeight = 60;
                return {
                    top: "".concat(parentProps.top - (((_a = activeMenu.submenu) === null || _a === void 0 ? void 0 : _a.length) || 0) * rowHeight, "px"),
                    left: "".concat(parentProps.left, "px"),
                };
        }
        return {};
    };
    var animationClasses = {
        enter: DropDownMenu_module_scss_1.default["menuEnter".concat(menuPosition)],
        enterActive: DropDownMenu_module_scss_1.default["menuEnterActive".concat(menuPosition)],
        exit: DropDownMenu_module_scss_1.default["menuExit".concat(menuPosition)],
        exitActive: DropDownMenu_module_scss_1.default["menuExitActive".concat(menuPosition)],
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        menuItems.submenu ? (react_1.default.createElement(react_1.default.Fragment, null,
            label && react_1.default.createElement("label", null, label),
            react_1.default.createElement("button", { style: { width: "".concat(menuItems.title.length * 1.6, "ch") }, "aria-expanded": isOpen, ref: parentRef, className: DropDownMenu_module_scss_1.default.title, onClick: handleMenuToggle },
                react_1.default.createElement("span", null, activeMenu.title),
                react_1.default.createElement(Icons_1.ArrowIcon, { className: DropDownMenu_module_scss_1.default.arrow, direction: arrowPosition() })))) : (react_1.default.createElement(Link_1.default, { href: activeMenu.url, className: DropDownMenu_module_scss_1.default.titleLink, style: { maxWidth: "".concat(menuItems.title.length * 1.6, "ch") } }, activeMenu.title)),
        react_1.default.createElement(react_transition_group_1.CSSTransition, { nodeRef: menuRef, in: isOpen, timeout: 300, classNames: animationClasses, onExited: function () {
                setActiveMenu(menuItems);
            }, unmountOnExit: true },
            react_1.default.createElement("ul", { ref: menuRef, className: DropDownMenu_module_scss_1.default.menu, style: __assign({ maxWidth: "fit-content", minWidth: "".concat(parentProps.width, "px") }, getMenuPosition()) }, (_b = activeMenu.submenu) === null || _b === void 0 ? void 0 : _b.map(function (item, index) {
                return (react_1.default.createElement(MenuItems, { setMenu: function (menu) {
                        setIsOpen(false);
                        setActiveMenu(menu);
                        setIsOpen(true);
                    }, arrowPosition: getArrowDirection(menuPosition, false), key: index, item: item }));
            })))));
}
function MenuItems(_a) {
    var item = _a.item, setMenu = _a.setMenu, arrowPosition = _a.arrowPosition;
    return (react_1.default.createElement("li", null, item.hasOwnProperty("submenu") ? (react_1.default.createElement("button", { type: "button", onClick: function () {
            if (setMenu)
                setMenu(item);
        } },
        item.title,
        react_1.default.createElement(Icons_1.ArrowIcon, { className: DropDownMenu_module_scss_1.default.submenuArrow, direction: arrowPosition }))) : (react_1.default.createElement(Link_1.default, { className: DropDownMenu_module_scss_1.default.linkTest, href: item.url }, item.title))));
}
exports.MenuItems = MenuItems;
exports.default = DropDownMenu;
