"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useClickOutside(onClickOutside, ignoreRef) {
    var ref = (0, react_1.useRef)();
    var handleClickOutside = function (event) {
        if (!ref.current ||
            ref.current.contains(event.target) ||
            (ignoreRef !== undefined && ignoreRef.current.contains(event.target))) {
            return;
        }
        onClickOutside();
    };
    (0, react_1.useEffect)(function () {
        document.addEventListener("click", handleClickOutside, true);
        return function () {
            document.removeEventListener("click", handleClickOutside, true);
        };
    }, []);
    return { ref: ref };
}
exports.default = useClickOutside;
